"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var cookie = _interopRequireWildcard(require("cookie"));

var _utils = require("./utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

class Cookie {
  constructor(options) {
    this.path = options.path || '/';
    this.maxAge = options.maxAge ? (0, _utils.parseToMs)(options.maxAge) : null;
    this.httpOnly = options.httpOnly || true;
    this.domain = options.domain || null;
    this.sameSite = options.sameSite || null;
    this.secure = options.secure || false;
    if (this.maxAge) this.expires = new Date(Date.now() + this.maxAge);
  }

  resetExpires() {
    if (this.expires && this.maxAge) {
      this.expires = new Date(Date.now() + this.maxAge);
    }
  }

  get cookieOptions() {
    return {
      path: this.path,
      httpOnly: this.httpOnly,
      expires: this.expires || null,
      domain: this.domain,
      sameSite: this.sameSite,
      secure: this.secure
    };
  }

  serialize(name, val) {
    return cookie.serialize(name, val, this.cookieOptions);
  }

}

var _default = Cookie;
exports.default = _default;