"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var Promise = _interopRequireWildcard(require("bluebird"));

var _store = _interopRequireDefault(require("./store"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const MemoryStoreSession = {};

class MemoryStore extends _store.default {
  constructor() {
    super();
  }

  get(sid) {
    const self = this;
    let expires;
    let sess = MemoryStoreSession[sid];

    if (sess) {
      sess = JSON.parse(sess);
      expires = typeof sess.cookie.expires === 'string' ? new Date(sess.cookie.expires) : sess.cookie.expires;

      if (!expires || new Date() < expires) {
        return Promise.resolve(sess);
      }

      self.destroy(sid);
      return Promise.resolve(null);
    }

    return Promise.resolve(null);
  }

  set(sid, sess) {
    MemoryStoreSession[sid] = JSON.stringify(sess);
    return Promise.resolve();
  }

  all() {
    const arr = [];
    const keys = Object.keys(MemoryStoreSession);

    for (let i = 0, len = keys.length; i < len; i += 1) {
      arr.push(MemoryStoreSession[keys[i]]);
    }

    return Promise.resolve(arr);
  }

  destroy(sid) {
    Promise.resolve(delete MemoryStoreSession[sid]);
  }

}

var _default = MemoryStore;
exports.default = _default;