"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

class Session {
  constructor(req, sess) {
    Object.defineProperty(this, 'req', {
      value: req
    });
    Object.defineProperty(this, 'id', {
      value: req.sessionId
    });

    if (typeof sess === 'object') {
      Object.assign(this, sess);
    }
  }

  touch() {
    this.cookie.resetExpires();

    if (typeof this.req.sessionStore.touch === 'function') {
      return this.req.sessionStore.touch(this.id, this);
    }

    console.warn('store does not implement touch()');
    return Promise.resolve();
  }

  save() {
    this.cookie.resetExpires();
    return this.req.sessionStore.set(this.id, this);
  }

  destroy() {
    delete this.req.session;
    return this.req.sessionStore.destroy(this.id);
  }

}

var _default = Session;
exports.default = _default;