"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _events = _interopRequireDefault(require("events"));

var _session = _interopRequireDefault(require("./session"));

var _cookie = _interopRequireDefault(require("./cookie"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Store extends _events.default {
  constructor() {
    super();

    _events.default.call(this);
  }

  generate(req, genId, cookieOptions) {
    req.sessionId = genId;
    req.session = new _session.default(req);
    req.session.cookie = new _cookie.default(cookieOptions);
    return req.session;
  }

  createSession(req, sess) {
    const thisSess = sess;
    const expires = thisSess.cookie.expires;
    thisSess.cookie = new _cookie.default(thisSess.cookie);
    if (typeof expires === 'string') thisSess.cookie.expires = new Date(expires);
    req.session = new _session.default(req, thisSess);
    return req.session;
  }

}

var _default = Store;
exports.default = _default;